package com.example.mangoswordsearch;

import androidx.appcompat.app.AppCompatActivity;

import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;

public class CategoryChoices extends AppCompatActivity {

    public static final String CATEGORY = "PKG_CATEGORY"; //contains data to pass through intent
    public static final String CATEGORYWORDS = "PKG_CATEGORYWORDS"; //contains data to pass through intent
    String[] categorywords; //words to be passed to the gameplay screen
    String categorychoice; //choice of category
    int level; //based on what is extracted from intent for difficulty level, there will be more/less words of shorter/longer length(EXTRA)

    //Easy=7 Words-Short(Less than 5 letters) Length-10x10 Grid, Medium=10 Words-Medium(Less than 10 Letters) Length-14x12 Grid, Hard=13 Words-Long(Less than 15 Letters) Length-16x14 Grid

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_category_choices);

        //Enables Immersive Full Screen
        getWindow().getDecorView().setSystemUiVisibility(
                View.SYSTEM_UI_FLAG_FULLSCREEN | View.SYSTEM_UI_FLAG_HIDE_NAVIGATION | View.SYSTEM_UI_FLAG_IMMERSIVE_STICKY |
                        View.SYSTEM_UI_FLAG_LAYOUT_FULLSCREEN | View.SYSTEM_UI_FLAG_LAYOUT_HIDE_NAVIGATION | View.SYSTEM_UI_FLAG_LAYOUT_STABLE
        );

        //GRAB INTENT FROM TITLE SCREEN CONCERNING DIFFICULTY TO KNOW HOW MANY WORDS/SIZE OF GRID TO USE(EXTRA)

        Button fruitbtn = (Button) findViewById(R.id.fruitsbutton);
        fruitbtn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                Intent intent = new Intent(CategoryChoices.this, GamePlay.class);
                //Pass Intent to GamePlay Activity to signify you chose this button
                //Easy Level
                categorywords = new String[] {"MANGO", "APPLE", "PEACH", "GRAPE", "LEMON", "PEAR", "LIME"};
                categorychoice = "FRUITS";
                intent.putExtra(CATEGORYWORDS, categorywords);
                intent.putExtra(CATEGORY, categorychoice);
                startActivity(intent);}
        });
        Button animalbtn = (Button) findViewById(R.id.animalsbutton);
        animalbtn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                Intent intent = new Intent(CategoryChoices.this, GamePlay.class);
                //Pass Intent to GamePlay Activity to signify you chose this button
                //Easy Level
                categorywords = new String[] {"FISH", "TIGER", "DOG", "SHEEP", "CAMEL", "MOOSE", "KOALA"};
                categorychoice = "ANIMALS";
                intent.putExtra(CATEGORYWORDS, categorywords);
                intent.putExtra(CATEGORY, categorychoice);
                startActivity(intent);}
        });
        Button videogamebtn = (Button) findViewById(R.id.videogamesbutton);
        videogamebtn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                Intent intent = new Intent(CategoryChoices.this, GamePlay.class);
                //Pass Intent to GamePlay Activity to signify you chose this button
                //Easy Level
                categorywords = new String[] {"MARIO", "SONIC", "GAME", "XBOX", "ATARI", "STEAM", "MOUSE"};
                categorychoice = "VIDEO GAMES";
                intent.putExtra(CATEGORYWORDS, categorywords);
                intent.putExtra(CATEGORY, categorychoice);
                startActivity(intent);}
        });
        Button compscibtn = (Button) findViewById(R.id.computersciencebutton);
        compscibtn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                Intent intent = new Intent(CategoryChoices.this, GamePlay.class);
                //Pass Intent to GamePlay Activity to signify you chose this button
                //Easy Level
                categorywords = new String[] {"LINK", "NODE", "LOOP", "BUG", "JAVA", "XML", "CODE"};
                categorychoice = "COMPUTER SCIENCE";
                intent.putExtra(CATEGORYWORDS, categorywords);
                intent.putExtra(CATEGORY, categorychoice);
                startActivity(intent);}
        });
        /*Button mangobtn = (Button) findViewById(R.id.mangosbutton);
        mangobtn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                Intent intent = new Intent(CategoryChoices.this, GamePlay.class);
                //Pass Intent to GamePlay Activity to signify you chose this button
                //Easy Level
                categorywords = new String[]{"MEDIEVAL", "COMPUTER", "ULTIMATE", "ELECTRIC", "IDEOLOGY", "TROPICAL", "BACHELOR"};
                categorychoice = "MANGO";
                intent.putExtra(CATEGORYWORDS, categorywords);
                intent.putExtra(CATEGORY, categorychoice);
                startActivity(intent);
            }
        });*/
    }
}