package com.example.mangoswordsearch;

import androidx.appcompat.app.AppCompatActivity;

import android.app.ProgressDialog;
import android.content.Intent;
import android.os.AsyncTask;
import android.os.Bundle;
import android.os.Parcelable;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.HorizontalScrollView;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.riclage.boardview.BoardPoint;
import com.riclage.boardview.BoardWord;
import com.riclage.boardview.LetterTileView;
import com.riclage.boardview.TileView;
import com.riclage.boardview.TiledBoardView;
import com.riclage.boardview.WordSearchBoardView;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Scanner;
import java.util.concurrent.ExecutionException;

public class GamePlay extends AppCompatActivity {
    public static final String RESULT = "PKG_RESULT"; //contains data to pass through intent
    public static final String RESULTCATEGORY = "PKG_RESULT_CATEGORY"; //contains data to pass through intent

    public String results; //for file data retrieval which will be parsed

    com.riclage.boardview.BoardView grid;
    //GridView for WordSearch Box
    //GridView wordsearchgrid; //old
    WordSearchBoardView boardView; //new
    //TextViews for WordSearch Bank
    TextView word; TextView word2; TextView word3; TextView word4; TextView word5; TextView word6; TextView word7;
    //Category for Word Search Grid
    TextView cattext;
    //WordSearch Box Size(Default 10x10)
    int GRIDROWS=10;
    int GRIDCOLUMNS=10;
    //1D Array for Words According to Category Chosen
    String[] words;
    List<BoardWord> targetWords;
    //Category
    String wordcateg;
    //2D Array for WordSearch Grid Letters, Randomized for each onCreate
    //char[][] letters = new char[GRIDROWS][GRIDCOLUMNS];
    //Counts how many words have been found
    int wordcount = 0;

    //String of filename to import from
    String filename;
    //For Background Task to Retrieve Server Data
    ProgressDialog pd;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_game_play);

        //Enables Immersive Full Screen
        getWindow().getDecorView().setSystemUiVisibility(
                View.SYSTEM_UI_FLAG_FULLSCREEN | View.SYSTEM_UI_FLAG_HIDE_NAVIGATION | View.SYSTEM_UI_FLAG_IMMERSIVE_STICKY |
                        View.SYSTEM_UI_FLAG_LAYOUT_FULLSCREEN | View.SYSTEM_UI_FLAG_LAYOUT_HIDE_NAVIGATION | View.SYSTEM_UI_FLAG_LAYOUT_STABLE
        );

        words = new String[] {"NULL", "NULL", "NULL", "NULL", "NULL", "NULL", "NULL"}; //to avoid reading from a null array

        //Data Attained from Previous Screen to Attain Words from Chosen Category for use in Grid and Word Bank
        Intent intent = getIntent();
        if(intent.hasExtra(CategoryChoices.CATEGORY)) {
            words = intent.getStringArrayExtra(CategoryChoices.CATEGORYWORDS);
            wordcateg = intent.getStringExtra(CategoryChoices.CATEGORY);
        }
        if(intent.hasExtra(CreateGame.CREATE)) {
            words = intent.getStringArrayExtra(CreateGame.CREATE);
            wordcateg = "CUSTOM";
        }
        /*if(intent.hasExtra(TitleScreen.RESUME)) {
            boardView.onRestoreInstanceState(savedInstanceState);
        }*/
        if(intent.hasExtra(TitleScreen.IMPORT))
        {
            filename = intent.getStringExtra(TitleScreen.IMPORT);
            //Executes and waits for file data before moving on
            try {
                new RetrieveData().execute().get(); //Executes background thread to read the website with the JSON file
            } catch (ExecutionException | InterruptedException e) {
                e.printStackTrace();
            }

            //Parsing
            String datavalues = results; //Gets the string containing the contents of the txt file from COMPSCI04

            //parse the string
            String[] seperated = datavalues.split(","); //seperate by commas

            for (int i = 0; i < 6; i++) //7 words
            {
                words[i] = seperated[i];
            }
            //erases \n
            words[6] = seperated[6].trim();

            //1D Array
            words = words; //Already has itself
            wordcateg = "IMPORT";
        }

        if(intent.hasExtra(CategoryChoices.CATEGORY) || intent.hasExtra(CreateGame.CREATE) || intent.hasExtra(TitleScreen.IMPORT)) { //if not resume
            boardView = (WordSearchBoardView) findViewById(R.id.board_view);
            targetWords = boardView.generateRandomLetterBoard(Arrays.asList(words)); //these are the words used for the game
            //targetWords has all words with location and direction
            //Using class BoardWord.java

            //Initializes Word Bank Text Views to be able to be Crossed Off
            word = (TextView) findViewById(R.id.wordtext1);
            word2 = (TextView) findViewById(R.id.wordtext2);
            word3 = (TextView) findViewById(R.id.wordtext3);
            word4 = (TextView) findViewById(R.id.wordtext4);
            word5 = (TextView) findViewById(R.id.wordtext5);
            word6 = (TextView) findViewById(R.id.wordtext6);
            word7 = (TextView) findViewById(R.id.wordtext7);

            cattext = (TextView) findViewById(R.id.categorytitle);
            cattext.setText(wordcateg);

            WordBank(words);
        }

        //color for crossing out words in word bank
        int crossedout = getResources().getColor(R.color.crossed);

        //Sets the listener for when a word is selected by the user
        boardView.setOnWordSelectedListener(new WordSearchBoardView.OnWordSelectedListener() {
            @Override
            public boolean onWordSelected(BoardWord selectedWord) {
                if (targetWords.contains(selectedWord)) {
                    //Cross off word in word bank
                    if(word.getText().toString().equals(selectedWord.toString()))
                    {
                        word.setTextColor(crossedout);
                        word.setTextSize(28);
                        wordcount++;
                    }else if(word2.getText().toString().equals(selectedWord.toString()))
                    {
                        word2.setTextColor(crossedout);
                        word2.setTextSize(28);
                        wordcount++;
                    } else if(word3.getText().toString().equals(selectedWord.toString()))
                    {
                        word3.setTextColor(crossedout);
                        word3.setTextSize(28);
                        wordcount++;
                    } else if(word4.getText().toString().equals(selectedWord.toString()))
                    {
                        word4.setTextColor(crossedout);
                        word4.setTextSize(28);
                        wordcount++;
                    } else if(word5.getText().toString().equals(selectedWord.toString()))
                    {
                        word5.setTextColor(crossedout);
                        word5.setTextSize(28);
                        wordcount++;
                    } else if(word6.getText().toString().equals(selectedWord.toString()))
                    {
                        word6.setTextColor(crossedout);
                        word6.setTextSize(28);
                        wordcount++;
                    } else if(word7.getText().toString().equals(selectedWord.toString()))
                    {
                        word7.setTextColor(crossedout);
                        word7.setTextSize(28);
                        Log.e("Word Count", "Last Word");
                        wordcount++;
                    }

                    if(wordcount == 7)
                    {
                        Log.e("Word Count", String.valueOf(wordcount));
                        Intent intent = new Intent(GamePlay.this, Results.class);
                        intent.putExtra(RESULT, words);
                        intent.putExtra(RESULTCATEGORY, wordcateg);
                        startActivity(intent);
                    }

                    return true;
                }
                return false;
            }
        });

        //Assigns GridView Variable
        /*wordsearchgrid = (GridView) findViewById(R.id.wordsearchGrid);
        wordsearchgrid.setNumColumns(GRIDCOLUMNS); //sets number of columns*/
        /*Random r = new Random();
        char letter;
        //Randomize Letters for Array Based on Grid Size(Goes From Row to Row)
        for(int i = 0; i< GRIDROWS; i++)
        {
            for(int k = 0; k< GRIDCOLUMNS; k++)
            {
                letter = (char)(r.nextInt(26)+'a'); //CHANGE TO CAPITAL LETTERS
                letters[i][k] = letter;
            }
        }*/

        /*//Adapter that will display(Inflates) each TextView with the Data Provided
        MainAdapter wordAdapter = new MainAdapter(GamePlay.this, letters);
        wordsearchgrid.setAdapter(wordAdapter); //Displays Grid
        //Displays a toast on what letter you chose(TEMPORARY)
        wordsearchgrid.setOnItemClickListener(new AdapterView.OnItemClickListener(){
            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                Toast.makeText(getApplicationContext(), "Clicked On "+letters[+position][+position], Toast.LENGTH_SHORT).show();
            }
        });*/


        Button hintsbtn = (Button) findViewById(R.id.hintsbutton);
        hintsbtn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                //Hints button action, provides hints
                BoardPoint strtPoint;
                BoardPoint hintPoint;
                int brdsize = boardView.letterBoard.length;

                //for every word go through board to see if it matches then make sure the word is there
                for(int w = 0; w < targetWords.size(); w++) {
                    for (int x = 0; x < brdsize; x++) //row
                    {
                        for (int y = 0; y < brdsize; y++) //column
                        {
                            strtPoint = targetWords.get(w).getWordStartPoint();
                            hintPoint = new BoardPoint(x,y);
                            if(hintPoint.equals(strtPoint) && !boardView.getChildAt(x,y).isSelected()) //if start point is the same and its not selected
                            {
                                boardView.getChildAt(x,y).setPressed(true);
                            }
                        }
                    }
                }
            }
        });

        Button scramblebtn = (Button) findViewById(R.id.scramblebutton);
        scramblebtn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) { //restarts activity to mimic the feel of scrambling
                Intent intent = getIntent();
                finish();
                startActivity(intent);
            }
        });

        /* COULD HAVE USED SHARED PREFERENCES TO BE ABLE TO SAVE GAME FOREVER */
        Button savebtn = (Button) findViewById(R.id.savebutton);
        savebtn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                Intent intent = new Intent(GamePlay.this, TitleScreen.class);
                boardView.onSaveInstanceState();
                startActivity(intent);}
        });
    }

    public void WordBank(String[] words) //uses word array that has the category's words and displays them in a word bank
    {
        int e = 0; //counter to go through all words in the words array and have their own textview
        //stops when all words have been placed in the wordbank(at least 7 to start(Easy))
        TextView word = (TextView) findViewById(R.id.wordtext1);
        word.setText(words[e]);
        e++;
        word = (TextView) findViewById(R.id.wordtext2);
        word.setText(words[e]);
        e++;
        word = (TextView) findViewById(R.id.wordtext3);
        word.setText(words[e]);
        e++;
        word = (TextView) findViewById(R.id.wordtext4);
        word.setText(words[e]);
        e++;
        word = (TextView) findViewById(R.id.wordtext5);
        word.setText(words[e]);
        e++;
        word = (TextView) findViewById(R.id.wordtext6);
        word.setText(words[e]);
        e++;
        word = (TextView) findViewById(R.id.wordtext7);
        word.setText(words[e]);
        //end
    }

    //Retrieves Data from Server COMPSCI04 import folder
    private class RetrieveData extends AsyncTask<String, String, String> {

        protected void onPreExecute() {
            super.onPreExecute();

            pd = new ProgressDialog(GamePlay.this);
            pd.setMessage("Please wait");
            pd.setCancelable(false);
            pd.show();
        }

        protected String doInBackground(String... params) {
            HttpURLConnection connection = null; //allows for a connection to be made
            BufferedReader reader = null; //allows for reading of the JSON file

            try {
                URL url = new URL("https://compsci04.snc.edu/cs460/2021/madrjc/import/"+filename);
                connection = (HttpURLConnection) url.openConnection();
                connection.connect();

                InputStream stream = connection.getInputStream(); //get what is on the url

                reader = new BufferedReader(new InputStreamReader(stream));

                StringBuffer buffer = new StringBuffer(); //keeps all of the lines read
                String line = "";

                while ((line = reader.readLine()) != null) {
                    buffer.append(line+"\n");
                    Log.d("Response: ", "> " + line);   //Allows for all of the data contents to be displayed in the Log
                }
                results = buffer.toString(); //allows for the global variable to get the results from this background thread and able to be used in the OnCreate function
                return buffer.toString();

            } catch (MalformedURLException e) {
                e.printStackTrace();
            } catch (IOException e) {
                e.printStackTrace();
            } finally {
                if (connection != null) {
                    connection.disconnect();
                }
                try {
                    if (reader != null) {
                        reader.close();
                    }
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            return null;
        }

        @Override
        protected void onPostExecute(String result) {
            super.onPostExecute(result);
            if (pd.isShowing()){
                pd.dismiss();
            }
        }
    }
}