package com.example.mangoswordsearch;

import androidx.annotation.RequiresApi;
import androidx.appcompat.app.AppCompatActivity;
import androidx.fragment.app.FragmentActivity;

import android.annotation.SuppressLint;
import android.app.Fragment;
import android.app.FragmentManager;
import android.app.FragmentTransaction;
import android.content.Intent;
import android.content.pm.ActivityInfo;
import android.os.Build;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.view.Window;
import android.view.WindowManager;
import android.view.animation.Animation;
import android.view.animation.AnimationUtils;
import android.widget.Button;
import android.widget.EditText;
import android.widget.FrameLayout;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;

import com.google.android.material.floatingactionbutton.FloatingActionButton;

public class TitleScreen extends AppCompatActivity implements Animation.AnimationListener {

    public static final String RESUME = "PKG_RESUME"; //contains data to pass through intent
    public static final String IMPORT = "PKG_IMPORT"; //contains data to pass through intent
    String file;

    HelpFragment fragmenthelp = new HelpFragment();
    TextView helper;
    TextView background;
    View frag;

    @SuppressLint("ResourceAsColor")
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_title_screen);

        //Enables Immersive Full Screen
        getWindow().getDecorView().setSystemUiVisibility(
                View.SYSTEM_UI_FLAG_FULLSCREEN | View.SYSTEM_UI_FLAG_HIDE_NAVIGATION | View.SYSTEM_UI_FLAG_IMMERSIVE_STICKY |
                        View.SYSTEM_UI_FLAG_LAYOUT_FULLSCREEN | View.SYSTEM_UI_FLAG_LAYOUT_HIDE_NAVIGATION | View.SYSTEM_UI_FLAG_LAYOUT_STABLE
        );

        //POSSIBLY A DIFFICULTY FRAGMENT EMBEDDED HERE(EXTRA)
        //NIGHT MODE(EXTRA)

        helper = (TextView) findViewById(R.id.helptext);
        //background = (TextView) findViewById(R.id.helpview);
        frag = (View) findViewById(R.id.fragment2);

        //Hide Fragment
        androidx.fragment.app.FragmentTransaction transaction = getSupportFragmentManager().beginTransaction();
        transaction.add(R.id.fragment2,fragmenthelp);
        transaction.hide(fragmenthelp);
        transaction.commit();

        helper.setTextColor(android.R.color.white); //to hide text
        frag.setBackgroundResource(android.R.color.white);

        ImageView mango = (ImageView) findViewById(R.id.mangoView);

        //Initialize Animation
        Animation anime = AnimationUtils.loadAnimation(this, R.anim.bounce);
        anime.setFillAfter(true);
        anime.setAnimationListener(this);

        mango.startAnimation(anime);

        //Filename for Import
        file = null;
        EditText fileedit = (EditText) findViewById(R.id.filenameedit);

        Button startbtn = (Button) findViewById(R.id.startbutton);
        startbtn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                Intent intent = new Intent(TitleScreen.this, CategoryChoices.class);
                startActivity(intent);}
        });

        Button creategamebtn = (Button) findViewById(R.id.creategamebutton);
        creategamebtn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                Intent intent = new Intent(TitleScreen.this, CreateGame.class);
                startActivity(intent);}
        });

        Button resumebtn = (Button) findViewById(R.id.resumebutton);
        resumebtn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                Intent intent = new Intent(TitleScreen.this, GamePlay.class);
                intent.putExtra(RESUME,true);
                //startActivity(intent);
                finish();
            }
        });

        FloatingActionButton helpbtn = (FloatingActionButton) findViewById(R.id.floatinghelpbutton);
        helpbtn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                androidx.fragment.app.FragmentTransaction transaction = getSupportFragmentManager().beginTransaction();

                transaction.setCustomAnimations(android.R.animator.fade_in,
                        android.R.animator.fade_out);

                if (fragmenthelp.isHidden()) {
                    transaction.show(fragmenthelp);
                    Log.d("hidden","Show");
                    helper.setTextColor(android.R.color.black); //to hide text
                    frag.setBackgroundResource(android.R.color.holo_blue_bright);
                } else {
                    transaction.hide(fragmenthelp);
                    Log.d("Shown","Hide");
                    helper.setTextColor(android.R.color.white); //to hide text
                    frag.setBackgroundResource(android.R.color.white);
                }

                transaction.commit();
            }
        });

        Button importbtn = (Button) findViewById(R.id.importbutton);
        importbtn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                file = fileedit.getText().toString();
                if(file.matches(""))//if there is no input
                {
                    Toast.makeText(getApplicationContext(),"You must enter a file name from cs460/2021/madrjc/import folder!",Toast.LENGTH_LONG).show();
                    return;
                }
                Intent intent = new Intent(TitleScreen.this, GamePlay.class);
                intent.putExtra(IMPORT, file);
                startActivity(intent);
            }
        });
    }

    @Override
    public void onAnimationStart(Animation animation) {

    }

    @Override
    public void onAnimationEnd(Animation animation) {

    }

    @Override
    public void onAnimationRepeat(Animation animation) {

    }
}