package com.riclage.boardview;

/**
 * Used by Julio on 30/3/2021
 * Created by Ricardo on 03/02/2016.
 */

//toString might be useful, this class is for finding which way to create rows/columns and specifies a specific point on the board
public class BoardPoint {
    public final int row, col;

    public BoardPoint(int row, int col) {
        this.row = row;
        this.col = col;
    }

    //Direction for words, as the user goes from one tile to the other, it determines direction by where the next tile is selected from
    public @com.riclage.boardview.WordSearchBoardView.Direction int getDirectionFrom(BoardPoint other) {
        if (row == other.row
                && col < other.col) {
            return WordSearchBoardView.DIRECTION_RIGHT_HORIZONTAL;
        } else if (row == other.row
                && col > other.col) {
            return WordSearchBoardView.DIRECTION_LEFT_HORIZONTAL;
        } else if (row < other.row
                && col == other.col) {
            return WordSearchBoardView.DIRECTION_DOWN_VERTICAL;
        } else if (row > other.row
                && col == other.col) {
            return WordSearchBoardView.DIRECTION_UP_VERTICAL;
        } else if (row < other.row
                && col < other.col
                && row - other.row == col - other.col) {
            return WordSearchBoardView.DIRECTION_SOUTH_EAST_DIAGONAL;
        } else if (row < other.row
                && col > other.col
                && row - other.row == ((col - other.col) * -1)) {
            return WordSearchBoardView.DIRECTION_SOUTH_WEST_DIAGONAL;
        } else if (row > other.row
                && col > other.col
                && ((row - other.row) * -1) == ((col - other.col) * -1)) {
            return WordSearchBoardView.DIRECTION_NORTH_WEST_DIAGONAL;
        } else if (row > other.row
                && col < other.col
                && ((row - other.row) * -1) == col - other.col) {
            return WordSearchBoardView.DIRECTION_NORTH_EAST_DIAGONAL;
        }
        else {
            return WordSearchBoardView.DIRECTION_UNKNOWN;
        }
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || !(o instanceof BoardPoint)) return false;

        BoardPoint that = (BoardPoint) o;
        return row == that.row && col == that.col;
    }

    @Override
    public int hashCode() {
        int result = row;
        result = 31 * result + col;
        return result;
    }

    @Override
    public String toString() {
        return "[" + row + ", " + col + "]";
    }
}
